function varargout = XyTune(varargin)
% XYTUNE MATLAB code for XyTune.fig
%      XYTUNE, by itself, creates a new XYTUNE or raises the existing
%      singleton*.
%
%      H = XYTUNE returns the handle to a new XYTUNE or the handle to
%      the existing singleton*.
%
%      XYTUNE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in XYTUNE.M with the given input arguments.
%
%      XYTUNE('Property','Value',...) creates a new XYTUNE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before XyTune_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to XyTune_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help XyTune

% Last Modified by GUIDE v2.5 21-Mar-2015 08:48:29

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @XyTune_OpeningFcn, ...
                   'gui_OutputFcn',  @XyTune_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before XyTune is made visible.
function XyTune_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to XyTune (see VARARGIN)

% Choose default command line output for XyTune
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);
disp('XyTune, by Rich Wickstrom, Dec 2014');

%The first argument, if set, is the results directory.
if(length(varargin))
    handles.ResultsDir=varargin{1};
else
    handles.ResultsDir='results_dir';
end

%Set some vars that are globally needed
handles.FileNamePreface=get(handles.FileNamePreface,'String');
handles.Fs=44100;

%Draw the bar level bar graph
axes(handles.LevelBar);
x=[0 0 1 1 0];
y=[0 1 1 0 0];
patch(x,y,'r');
set(handles.LevelBar,'XTickLabel','')
set(handles.LevelBar,'YTickLabel','')
set(handles.LevelBar,'XTick',[])
set(handles.LevelBar,'YTick',[])
xlim([0,1e9]);%Make large to start with

%Read a structure that contains note strings and frequencies
load('Notes44.mat'); %Read a structure that has the note names and frequencies in it
%Makes available to all callbacks
handles.Notes = Notes;

%Generate an array of clip durations. As the bars get shorter, the decay is
%shorter and the FFT get's noisy unless the clip is shorter. Linearly
%adjust the FFT duration for each bar.
LongestDuration = 0.75;
ShortestDuration = 0.1;
for bar_num=1:44
    FFT_Duration(bar_num)=interp1([1 44],[LongestDuration ShortestDuration],bar_num);
end
%Makes available to all callbacks
handles.FFT_Duration = FFT_Duration;

%Makes available to all callbacks
guidata(hObject,handles);

%Plot the results for the current bar
BarNum=str2num(get(handles.BarNumber,'String'));
[Results, FileName, NumEntries]=LoadSaveResults(handles.ResultsDir, handles.FileNamePreface, BarNum);
if(~get(handles.BarNumber, 'UserData')) %First time through UserData is zero
    set(handles.BarNumber, 'UserData',NumEntries);
end
RunSelection=length(Results);
set(handles.BarNumber,'UserData',RunSelection);
set(handles.CurRun,'String',num2str(RunSelection));

AddToLogWindow(handles.LogWindow, sprintf('Read %d entries from file %s',...
    NumEntries, FileName));
if(~isempty(Results))
    PlotResults(handles, Results, RunSelection);
    Args=GetArgs(handles);
    AnalyzeClip(Results{NumEntries}.Clip, handles.Fs, 'Notes', handles.Notes, 'PlotFlag', true,...
        'PlotMaxFreq',Args.PlotMaxFreq,'SigmaMult',Args.SigmaMult, 'Duration', handles.FFT_Duration(BarNum),...
        'Window','hanning','DeltaCentsForced',[Results{RunSelection}.targ_freq, 2],'PSD_FigHand',handles.PSD_Graph);  
end




% UIWAIT makes XyTune wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = XyTune_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in Delete.
function Delete_Callback(hObject, eventdata, handles)
% hObject    handle to Delete (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
disp('Pushed delete button');
BarNum=str2num(get(handles.BarNumber,'String'));
RunSelection = get(handles.BarNumber, 'UserData');
[ResultsArray, FileName, NumEntries]=LoadSaveResults(handles.ResultsDir, handles.FileNamePreface, BarNum,[], RunSelection); %Delete the entry
AddToLogWindow(handles.LogWindow, sprintf('Deleted entry %d from file %s',RunSelection, FileName));
RunSelection=max(0,RunSelection-1);
set(handles.BarNumber,'UserData',RunSelection);
set(handles.CurRun,'String',num2str(RunSelection));
PlotResults(handles, ResultsArray, RunSelection);
Args=GetArgs(handles);
AnalyzeClip(ResultsArray{NumEntries}.Clip, handles.Fs, 'Notes', handles.Notes, 'PlotFlag', true,...
    'PlotMaxFreq',Args.PlotMaxFreq,'SigmaMult',Args.SigmaMult, 'Duration', handles.FFT_Duration(BarNum),...
    'Window','hanning','DeltaCentsForced',[ResultsArray{RunSelection}.targ_freq,2],'PSD_FigHand',handles.PSD_Graph);  



function BarNumber_Callback(hObject, eventdata, handles)
% hObject    handle to BarNumber (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of BarNumber as text
%        str2double(get(hObject,'String')) returns contents of BarNumber as a double
BarNum=str2double(get(hObject,'String'));
% load('Notes44.mat'); %Read a structure that has the note names and frequencies in it
set(handles.NoteString,'String',sprintf('%s %0.1f',handles.Notes.name{BarNum},handles.Notes.freq(BarNum)));
disp('BarNum callback');
% --- Executes on key press with focus on BarNumber and none of its controls.


function BarNumber_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to BarNumber (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
% BarNum=str2double(get(handles.BarNumber,'String'));
% %Read the results for this bar
% if(strcmp(eventdata.Key,'uparrow'))
%     BarNum=min(BarNum+1,length(handles.Notes.name));
%     [Results, FileName, NumEntries]=LoadSaveResults(handles.ResultsDir, handles.FileNamePreface, BarNum);
%     set(handles.NoteString,'String',handles.Notes.name{BarNum});
%     set(handles.BarNumber,'String',num2str(BarNum));
%     set(handles.BarNumber,'UserData',length(Results)); %Store the selected run number in UserData
% elseif(strcmp(eventdata.Key,'downarrow'))
%     BarNum=max(BarNum-1,1);
%     [Results, FileName, NumEntries]=LoadSaveResults(handles.ResultsDir, handles.FileNamePreface, BarNum);
%     set(handles.NoteString,'String',handles.Notes.name{BarNum});
%     set(handles.BarNumber,'String',num2str(BarNum));
%     set(handles.BarNumber,'UserData',length(Results)); %Store the selected run number in UserData
% elseif(strcmp(eventdata.Key,'leftarrow'))
%     [Results, FileName, NumEntries]=LoadSaveResults(handles.ResultsDir, handles.FileNamePreface, BarNum);
%     if(~get(handles.BarNumber, 'UserData')) %First time through UserData is zero
%         RunSelection=NumEntries;
%     else
%         RunSelection = get(handles.BarNumber, 'UserData');
%     end
%     set(handles.BarNumber,'UserData',max(RunSelection-1,1)); %Store the selected run number in UserData
% elseif(strcmp(eventdata.Key,'rightarrow'))
%     [Results, FileName, NumEntries]=LoadSaveResults(handles.ResultsDir, handles.FileNamePreface, BarNum);
%     if(~get(handles.BarNumber, 'UserData')) %First time through UserData is zero
%         RunSelection=NumEntries;
%     else
%         RunSelection = get(handles.BarNumber, 'UserData');
%     end
%     set(handles.BarNumber,'UserData',min(RunSelection+1,length(Results))); %Store the selected run number in UserData
% end
% 
% %Replot regardless of keypress
% RunSelection = get(handles.BarNumber, 'UserData');
% PlotResults(handles, Results, RunSelection);
% %Re-analyze just to get the plot recreated.
% AnalyzeClip(Results{RunSelection}.Clip, handles.Fs, 'Notes', handles.Notes, 'PlotFlag', true,...
%     'PlotMaxFreq',20000,'Duration', 0.5,'SigmaMult',4,'Window','hanning','PSD_FigHand',handles.PSD_Graph);  
% 
%     

% --- Executes during object creation, after setting all properties.
function BarNumber_CreateFcn(hObject, eventdata, handles)
% hObject    handle to BarNumber (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
set(hObject,'UserData',0); %Zero out the selected run number in UserData


function Tune_Threshold_Callback(hObject, eventdata, handles)
% hObject    handle to Tune_Threshold (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Tune_Threshold as text
%        str2double(get(hObject,'String')) returns contents of Tune_Threshold as a double

%Makes available to all callbacks



% --- Executes during object creation, after setting all properties.
function Tune_Threshold_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Tune_Threshold (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function Args=GetArgs(handles)
Args.Threshold = str2double(get(handles.Tune_Threshold,'String'));
Args.ClipDuration = str2double(get(handles.Tune_ClipDuration,'String'));
Args.PlotMaxFreq = str2double(get(handles.Tune_PlotMaxFreq,'String'));
Args.SigmaMult = str2double(get(handles.Tune_SigmaMult,'String'));
% fprintf(1,'Thresh: %f\n',(Args.Threshold));



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ----USER DEFINED FUNCTIONS:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function tune(eventdata, handles)

fprintf(2,'TOP of tune\n');
% freq	= str2double(get(handles.freq1,'String'));
% tone	= round(log(freq/440)/0.0578+58);
% tones	= [tone-2:tone+2];
% freqs	= 15.43379*exp(0.05776234*tones);
% notes	= getNotes(tones);
% 	
% axes(handles.calaxes1);
% semilogx(freq,1,'*');
% xlim([freqs(1) freqs(end)]);
% set(handles.calaxes1,'YTickLabel',[],'XTick',freqs,'XTickLabel',notes,'XGrid','on');
% 
% Fs		= 96000*2;
% twindow	= 0.5;
% r		= audiorecorder(Fs,16,1);
% data	= linspace(0,1,twindow*Fs)';
% 
% latestfit = 0;

Fs=44100;
FRAME_TIME = 0.1; %seconds
CLIP_DURATION = 2.0; %seconds
% LOUD_THRESHOLD = 10000;

SaveFlag=true; %IF true, then save each results to a file
BarStr='Testbar01';
% ResultsDir='results_dir';
FileNamePreface='XyloResults';


AR = dsp.AudioRecorder;
AR.NumChannels=1;
AR.SampleRate=Fs;
AR.SamplesPerFrame=FRAME_TIME * Fs;

AR.OutputDataType='int16';
AUDIO_MIN = double(intmin('int16'));
AUDIO_MAX = double(intmax('int16'));

totaldata=[];

Capturing=false;


while ishandle(gcbo)
	if	get(handles.OnOffButton,'UserData')==0
		break;
	end;
    
    drawnow; %Refresh the GUI

    %Get the configuration parameters
    Args=GetArgs(handles);
    
    %Get FrameTime seconds of data
    data=step(AR);
    %If this frame is loud then capture concatenate the next X seconds
    Peak =max(data);
%     set(handles.PeakString,'String',num2str(Peak));
    %Draw the bar graph level
    DrawBarLevel(handles.LevelBar,abs(Peak));
    
%     set(handles.LogWindow,'String',num2str(Peak));
%      fprintf(1,'Thresh: %f\n',AUDIO_MAX*(Args.Threshold));
    if(Peak > AUDIO_MAX*Args.Threshold)
        StopSeconds = now*86400 + Args.ClipDuration; %Keep reseting time if still loud
        if(Capturing~=true)
            Clip=[];
        end
        Capturing=true;
        set(handles.TriggeredState,'ForegroundColor','red');
    end
    
    if(Capturing)
        if(now*86400 < StopSeconds)
            Clip=[Clip;data];
        else
            set(handles.TriggeredState,'ForegroundColor','green');
            set(handles.RecordingState,'ForegroundColor','red');
            set(handles.RecordingState,'String','Processing');
            Capturing = false;
            %Process the clip
            disp('PROCESS THE CLIP');
%             ProcessClip(double(Clip)/AUDIO_MAX, Fs); 
%             plot([1:numel(Clip)]/Fs, Clip);ylim([AUDIO_MIN,AUDIO_MAX]);drawnow
            Clips=DelineateSoundClip(double(Clip)/AUDIO_MAX, Fs, 350, 0.1, 'PlotFlag',false);

            BarNum=str2num(get(handles.BarNumber,'String'));
            
%             for k=1:length(Clips)
            for k=1:1 %TODO: Only process first segment for now. (The subsequent peaks are noise?)
%                 Results = AnalyzeClip(Clips{k}, Fs, 'Notes', handles.Notes, 'PlotFlag', true,...
%                     'PlotMaxFreq',20000,'Duration', 0.5,'SigmaMult',4,'Window','hanning','PSD_FigHand',handles.PSD_Graph);  
                Args=GetArgs(handles);
                Results=AnalyzeClip(Clips{k}, handles.Fs, 'Notes', handles.Notes, 'PlotFlag', true,...
                    'PlotMaxFreq',Args.PlotMaxFreq,'SigmaMult',Args.SigmaMult, 'Duration', handles.FFT_Duration(BarNum),...
                    'Window','hanning','DeltaCentsForced',[handles.Notes.freq(BarNum),2],'PSD_FigHand',handles.PSD_Graph);  

                if(isstruct(Results))
                    if(SaveFlag)
                        Results.targ_freq = handles.Notes.freq(BarNum); 
                        Results.targ_note_name = handles.Notes.name{BarNum}; 
                        Results.datenum = now; 
%                         [FileName, NumEntries, AllResults]=SaveResults(handles.ResultsDir, handles.FileNamePreface, BarNum, Results);
                        [AllResults, FileName, NumEntries]=LoadSaveResults(handles.ResultsDir, handles.FileNamePreface, BarNum, Results);
                        RunSelection=length(AllResults);
                        set(handles.BarNumber,'UserData',RunSelection);
                        set(handles.CurRun,'String',num2str(RunSelection));


                        PlotResults(handles, AllResults, RunSelection);
%                         DateStr=datestr(now,'yyyymmdd_HHMMSS');
%                         FileName = ['results_dir/' DateStr '_' BarStr '.mat'];
% %                         fprintf(1, 'Saving to file: %s\n', FileName);
%                         save(FileName, 'Results');
%                         AddToLogWindow(handles.LogWindow, sprintf('Saving %0.1f second clip to file: %s',numel(Clips{k})/Fs,FileName));
                        AddToLogWindow(handles.LogWindow, sprintf('Saving %0.1f second clip to file: %s (num_entries=%d)',...
                            numel(Clips{k})/Fs, FileName, NumEntries));
                    else
                        AddToLogWindow(handles.LogWindow, 'No modes found...');
                    end
                end
            end
            set(handles.RecordingState,'ForegroundColor','green');
            set(handles.RecordingState,'String','Listening');
        end
        
    end
end;

function [ResultsArrayRtn, FilePath, NumEntries]=LoadSaveResults(ResultsDir, FileNamePreface, BarNum, Results, RunSelection)

%To avoid unnecessary reading make the results array persistent
persistent ResultsArray;
persistent CurBarNum;

%Initialize to disallowed value to force load on first access
CurBarNum=-1;

FileName = sprintf('%s_%02d.mat',FileNamePreface,BarNum);
FilePath = fullfile(ResultsDir,FileName);

%If 4 arguments, then saving. If only 3, then loading.
if(nargin==4) %SAVING
    %If it exists, then read it, append and re-save
    if exist(FilePath, 'file') == 2
        if(isempty(ResultsArray) ||(CurBarNum~=BarNum))
            load(FilePath); %Results stored in cell array ResultsArray
        end
        ResultsArray{end+1}=Results;
        save(FilePath,'ResultsArray');
    else
        ResultsArray{1}=Results;
        save(FilePath,'ResultsArray');
    end    
elseif(nargin==5) %Delete element
    ResultsArray(RunSelection)=[];
    save(FilePath,'ResultsArray');
else%LOADING
    if exist(FilePath, 'file') == 2
        if(isempty(ResultsArray) ||(CurBarNum~=BarNum))
            load(FilePath); %Results stored in cell array ResultsArray
        end
    else %File doesn't exist!
        ResultsArray=[];
    end    
end    

CurBarNum=BarNum;
ResultsArrayRtn = ResultsArray;
NumEntries=numel(ResultsArray);
    
    
    
    

function PlotResults(handles, Results, RunSelection)
% disp('Plotting results');
%Update the run number
set(handles.CurRun,'String',num2str(RunSelection));
thisResult=Results{RunSelection};

ratios = thisResult.f_pks/thisResult.targ_freq;
Energies = thisResult.E_pks;    


%Print the bar stats
BarNum = str2num(get(handles.BarNumber,'String'));
myStr = sprintf('%02d - %s - %0.1f', BarNum,...
            handles.Notes.name{BarNum},handles.Notes.freq(BarNum) );
set(handles.BarInfo,'String',myStr);

%Fundimental
centitone_base = 2^(1/1200);
cents_diff = log(thisResult.fund_freq/thisResult.targ_freq)/log(centitone_base);
set(handles.FundHz,'String',sprintf('%0.1f (%+0.0f)',thisResult.fund_freq, cents_diff));

%Second partial
targ_ratio=3.0;
thisRatio=thisResult.f_pks/thisResult.targ_freq;
[~,k]=min(abs(thisRatio-3)); %Closest index to ratio of 3
% set(handles.R12Ratio,'String',sprintf('%0.3f',thisRatio(k)));
cents_diff = log(thisRatio(k)/targ_ratio)/log(centitone_base);
set(handles.SecondPartial,'String',sprintf('%0.1f : %0.3f (%+0.0f)',thisResult.f_pks(k), thisRatio(k), cents_diff));

%Second partial
targ_ratio=6.0;
thisRatio=thisResult.f_pks/thisResult.targ_freq;
[~,k]=min(abs(thisRatio-6)); %Closest index to ratio of 3
cents_diff = log(thisRatio(k)/targ_ratio)/log(centitone_base);
set(handles.ThirdPartial,'String',sprintf('%0.1f : %0.3f (%+0.0f)',thisResult.f_pks(k), thisRatio(k), cents_diff));

% 
% [~,k]=min(abs(thisRatio-6)); %Closest index to ratio of 6
% set(handles.ThirdPartial,'String',sprintf('%0.3f',thisRatio(k)));
% 
% 
ratios = [];
run_nums = [];
Energies = [];
for i=1:numel(Results)
    run_nums = [run_nums i*ones(1,numel(Results{i}.f_pks))];
    ratios = [ratios Results{i}.f_pks/Results{i}.targ_freq];
    Energies = [Energies Results{i}.E_pks];    
end

%Plot the harmonics
%Scale the symbol size from 0-100 based on log energy
LogMin = min(log(Energies)); LogMax = max(log(Energies));
SymSize = 99*(log(Energies)-LogMin)/(LogMax-LogMin) + 1;

if(isempty(Results))
    axes(handles.ModeRatiosGraph);plot(1,1);drawnow; 
    axes(handles.ModeRatiosGraph_R11);plot(1,1);drawnow; 
    axes(handles.ModeRatiosGraph_R12);plot(1,1);drawnow; 
    axes(handles.ModeRatiosGraph_R13);plot(1,1);drawnow; 
    axes(handles.PSD_Graph);plot(1,1);drawnow;
    return;
end



axes(handles.ModeRatiosGraph);
% hold off;
if(run_nums)
    scatter(run_nums,ratios,SymSize);
end
ylim([0,8]); 
xlabel('Run Number'); ylabel('Ratio (relative to target)');
if(~isempty(run_nums))
    vline(RunSelection,'r-');
    xlim([0,max(run_nums)+1]);
end
hline(1,'r-');
hline(3,'r-');
hline(6,'r-');
% set(gca,'Xtick',1:numel(iaa))
% set(gca,'XtickLabel',CNN(ia))
grid
drawnow

%R11
% axes(handles.ModeRatiosGraph_R11);
% scatter(run_nums,ratios,SymSize,'x');
% 
% ylim([0.95,1.05]); 
% if(~isempty(run_nums))
%     vline(RunSelection,'r-');
%     xlim([0,max(run_nums)+1]);
% end
% xlabel('Run Number'); 
% ylabel('Ratio');
% grid;
% drawnow

%R11
y_lag=300
targ_ratio=1.0;
axes(handles.ModeRatiosGraph_R11);
cents_diff = log(ratios/targ_ratio)/log(centitone_base);
scatter(run_nums,cents_diff,SymSize,'x');
ylim([-y_lag,y_lag]); 
if(~isempty(run_nums))
    vline(RunSelection,'r-');
    xlim([0,max(run_nums)+1]);
    hline(-5);
    hline(5);
end
% xlabel('Run Number'); 
ylabel('Fund Error [cents]');
grid;
drawnow



%R12
targ_ratio=3.0;
axes(handles.ModeRatiosGraph_R12);
cents_diff = log(ratios/targ_ratio)/log(centitone_base);
scatter(run_nums,cents_diff,SymSize,'x');
ylim([-y_lag,y_lag]); 
if(~isempty(run_nums))
    vline(RunSelection,'r-');
    xlim([0,max(run_nums)+1]);
    hline(-5);
    hline(5);
end
% xlabel('Run Number'); 
ylabel('2nd Error [cents]');
grid;
drawnow

%R13
targ_ratio=6.0;
axes(handles.ModeRatiosGraph_R13);
cents_diff = log(ratios/targ_ratio)/log(centitone_base);
scatter(run_nums,cents_diff,SymSize,'x');
ylim([-500,500]); 
if(~isempty(run_nums))
    vline(RunSelection,'r-');
    xlim([0,max(run_nums)+1]);
end
ylabel('3rd Error [cents]');
grid;
drawnow

% scatter(run_nums,ratios,SymSize,'x');
% ylim([4,8]); 
% if(~isempty(run_nums))
%     vline(RunSelection,'r-');
%     xlim([0,max(run_nums)]+1);
% end
% % xlabel('Run Number'); 
% ylabel('Ratio');
% grid;
% drawnow


function DrawBarLevel(GraphHandle, level)

level=double(level+1)/double(intmax('int16'));
%  fprintf(1,'level: %f\n',1/level);
axes(GraphHandle);
% x=[0 0 1 1 0];
% y=[0 1 1 0 0];
% patch(x,y,'r');
xlim([0,1/level]); %Change the axis instead of the bar


function  AddToLogWindow(handle, str)

    NUM_LINES=5;
    CurStr=get(handle,'String');
    if(~iscell(CurStr))
        CurStr={CurStr};
    end
    if(numel(CurStr)>NUM_LINES-1)
        CurStr=CurStr(end-1:end);
    end
    set(handle,'String', [CurStr;str]);

    
    





% --- Executes on button press in OnOffButton.
function OnOffButton_Callback(hObject, eventdata, handles)
% hObject    handle to OnOffButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if get(hObject,'UserData')
	%IF ALREADY ON, TURN OFF:
	set(hObject,'UserData',0);
% 	set(hObject,'CData',RecDisabled)
	set(hObject,'String','OFF')
    set(hObject,'BackgroundColor','red');
    
else
	%IF NOT ALREADY ON, TURN ON:
	set(hObject,'UserData',1);
% 	set(hObject,'CData',RecEnabled)
	set(hObject,'String','ON')
    set(hObject,'BackgroundColor','green');
 	tune(eventdata, handles);
end;



function Tune_ClipDuration_Callback(hObject, eventdata, handles)
% hObject    handle to Tune_ClipDuration (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Tune_ClipDuration as text
%        str2double(get(hObject,'String')) returns contents of Tune_ClipDuration as a double


% --- Executes during object creation, after setting all properties.
function Tune_ClipDuration_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Tune_ClipDuration (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on key press with focus on figure1 and none of its controls.
function figure1_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  structure with the following fields (see FIGURE)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
% disp(eventdata);
BarNum=str2double(get(handles.BarNumber,'String'));
%
Results=[];
if(strcmp(eventdata.Key,'space'))
    if get(handles.OnOffButton,'UserData')
        %IF ALREADY ON, TURN OFF:
        set(handles.OnOffButton,'UserData',0);
    % 	set(hObject,'CData',RecDisabled)
        set(handles.OnOffButton,'String','OFF')
        set(handles.OnOffButton,'BackgroundColor','red');
    else
        %IF NOT ALREADY ON, TURN ON:
        set(handles.OnOffButton,'UserData',1);
    % 	set(hObject,'CData',RecEnabled)
        set(handles.OnOffButton,'String','ON')
        set(handles.OnOffButton,'BackgroundColor','green');
        tune(eventdata, handles);
    end
    return;
elseif(strcmp(eventdata.Key,'uparrow'))
    BarNum=mod(BarNum,length(handles.Notes.name)) + 1;
    [Results, FileName, NumEntries]=LoadSaveResults(handles.ResultsDir, handles.FileNamePreface, BarNum);
    set(handles.NoteString,'String',sprintf('%s %0.1f',handles.Notes.name{BarNum},handles.Notes.freq(BarNum)));
    set(handles.BarNumber,'String',num2str(BarNum));
    set(handles.BarNumber,'UserData',length(Results)); %Store the selected run number in UserData
elseif(strcmp(eventdata.Key,'downarrow'))
    BarNum=mod(BarNum-2,length(handles.Notes.name)) + 1; %wrap around
    [Results, FileName, NumEntries]=LoadSaveResults(handles.ResultsDir, handles.FileNamePreface, BarNum);
    set(handles.NoteString,'String',sprintf('%s %0.1f',handles.Notes.name{BarNum},handles.Notes.freq(BarNum)));
    set(handles.BarNumber,'String',num2str(BarNum));
    set(handles.BarNumber,'UserData',length(Results)); %Store the selected run number in UserData
elseif(strcmp(eventdata.Key,'leftarrow'))
    [Results, FileName, NumEntries]=LoadSaveResults(handles.ResultsDir, handles.FileNamePreface, BarNum);
    RunSelection = get(handles.BarNumber, 'UserData');
    RunSelection=mod(RunSelection-2,length(Results)) + 1; %Bump down and wrap around 
    set(handles.BarNumber,'UserData',RunSelection); %Store the selected run number in UserData
elseif(strcmp(eventdata.Key,'rightarrow'))
    [Results, FileName, NumEntries]=LoadSaveResults(handles.ResultsDir, handles.FileNamePreface, BarNum);
    RunSelection = get(handles.BarNumber, 'UserData');
    RunSelection=mod(RunSelection,length(Results)) + 1; %Bump up and wrap around 
%     set(handles.BarNumber,'UserData',min(RunSelection+1,length(Results))); %Store the selected run number in UserData
    set(handles.BarNumber,'UserData',RunSelection); %Store the selected run number in UserData
elseif(strcmp(eventdata.Key,'delete'))
    BarNum=str2num(get(handles.BarNumber,'String'));
    RunSelection = get(handles.BarNumber, 'UserData');
    [Results, FileName, NumEntries]=LoadSaveResults(handles.ResultsDir, handles.FileNamePreface, BarNum,[], RunSelection); %Delete the entry
    AddToLogWindow(handles.LogWindow, sprintf('Deleted entry %d from file %s (leaving %d entries)',RunSelection, FileName, NumEntries));
    RunSelection=max(0,RunSelection-1);
    set(handles.BarNumber,'UserData',RunSelection);
%     PlotResults(handles, ResultsArray, RunSelection);
%     Args=GetArgs(handles);
%     AnalyzeClip(ResultsArray{NumEntries}.Clip, handles.Fs, 'Notes', handles.Notes, 'PlotFlag', true,...
%         'PlotMaxFreq',Args.PlotMaxFreq,'Duration', Args.ClipDuration,'SigmaMult',Args.SigmaMult,...
%         'Window','hanning','PSD_FigHand',handles.PSD_Graph);  
    
end


%Replot regardless of keypress
    RunSelection = get(handles.BarNumber, 'UserData');
    set(handles.CurRun,'String',num2str(RunSelection));
    
    PlotResults(handles, Results, RunSelection);
if(~isempty(Results))
    %Re-analyze just to get the plot recreated.
    % AnalyzeClip(Results{RunSelection}.Clip, handles.Fs, 'Notes', handles.Notes, 'PlotFlag', true,...
    %     'PlotMaxFreq',20000,'Duration', 0.5,'SigmaMult',4,'Window','hanning','PSD_FigHand',handles.PSD_Graph);  
    Args=GetArgs(handles);
    AnalyzeClip(Results{RunSelection}.Clip, handles.Fs, 'Notes', handles.Notes, 'PlotFlag', true,...
        'PlotMaxFreq',Args.PlotMaxFreq,'SigmaMult',Args.SigmaMult, 'Duration', handles.FFT_Duration(BarNum),...
        'Window','hanning','DeltaCentsForced',[Results{RunSelection}.targ_freq,2],'PSD_FigHand',handles.PSD_Graph);  
end

    



% function [FilePath, NumEntries, ResultsArray]=SaveResults(ResultsDir, FileNamePreface, BarNum, Results)
% 
% 
% FileName = sprintf('%s_%02d.mat',FileNamePreface,BarNum);
% FilePath = fullfile(ResultsDir,FileName);
% 
% %If it exists, then read it, append and re-save
% if exist(FilePath, 'file') == 2
%     load(FilePath); %Results stored in cell array ResultsArray
%     ResultsArray{end+1}=Results;
%     save(FilePath,'ResultsArray');
% else
%     ResultsArray{1}=Results;
%     save(FilePath,'ResultsArray');
% end    
% 
% NumEntries=numel(ResultsArray);
% 
% function [Results, FilePath, NumEntries]=ReadResults(ResultsDir, FileNamePreface, BarNum)
% 
% FileName = sprintf('%s_%02d.mat',FileNamePreface,BarNum);
% FilePath = fullfile(ResultsDir,FileName);
% 
% load(FilePath); %Results stored in cell array ResultsArray
% Results = ResultsArray;
% 
% NumEntries=numel(ResultsArray);



function Tune_PlotMaxFreq_Callback(hObject, eventdata, handles)
% hObject    handle to Tune_PlotMaxFreq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Tune_PlotMaxFreq as text
%        str2double(get(hObject,'String')) returns contents of Tune_PlotMaxFreq as a double


% --- Executes during object creation, after setting all properties.
function Tune_PlotMaxFreq_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Tune_PlotMaxFreq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Tune_SigmaMult_Callback(hObject, eventdata, handles)
% hObject    handle to Tune_SigmaMult (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Tune_SigmaMult as text
%        str2double(get(hObject,'String')) returns contents of Tune_SigmaMult as a double


% --- Executes during object creation, after setting all properties.
function Tune_SigmaMult_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Tune_SigmaMult (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FileNamePreface_Callback(hObject, eventdata, handles)
% hObject    handle to FileNamePreface (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FileNamePreface as text
%        str2double(get(hObject,'String')) returns contents of FileNamePreface as a double
handles.FileNamePreface=get(hObject,'String');


% --- Executes during object creation, after setting all properties.
function FileNamePreface_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FileNamePreface (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
